Index: trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_en.ts
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_en.ts	(revision 54733)
+++ trunk/src/VBox/Frontends/VirtualBox/nls/VirtualBox_en.ts	(revision 54734)
@@ -3,7 +3,17 @@
 <TS version="2.0" language="en">
 <context>
+    <name>UIAddDiskEncryptionPasswordDialog</name>
+    <message numerus="yes">
+        <source>This virtual machine is password protected. Please enter the %n encryption password(s) below.</source>
+        <comment>This text is never used with n == 0. Feel free to drop the %n where possible, we only included it because of problems with Qt Linguist (but the user can see how many passwords are in the list and doesn&apos;t need to be told).</comment>
+        <translation>
+            <numerusform>This virtual machine is password protected. Please enter the encryption password below.</numerusform>
+            <numerusform>This virtual machine is password protected. Please enter the encryption passwords below.</numerusform>
+        </translation>
+    </message>
+</context>
+<context>
     <name>UIGChooserItemGroup</name>
     <message numerus="yes">
-        <location filename="../src/selector/graphics/chooser/UIGChooserItemGroup.cpp" line="663"/>
         <source>%n group(s)</source>
         <comment>Group item tool-tip / Group info</comment>
@@ -14,5 +24,4 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/selector/graphics/chooser/UIGChooserItemGroup.cpp" line="679"/>
         <source>%n machine(s)</source>
         <comment>Group item tool-tip / Machine info</comment>
@@ -23,5 +32,4 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/selector/graphics/chooser/UIGChooserItemGroup.cpp" line="680"/>
         <source>(%n running)</source>
         <comment>Group item tool-tip / Running machine info</comment>
@@ -50,5 +58,4 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/globals/UIMessageCenter.cpp" line="1573"/>
         <source>&lt;p&gt;The %n following virtual machine(s) are currently in a saved state: &lt;b&gt;%1&lt;/b&gt;&lt;/p&gt;&lt;p&gt;If you continue the runtime state of the exported machine(s) will be discarded. The other machine(s) will not be changed.&lt;/p&gt;</source>
         <comment>This text is never used with n == 0. Feel free to drop the %n where possible, we only included it because of problems with Qt Linguist (but the user can see how many machines are in the list and doesn&apos;t need to be told).</comment>
@@ -62,5 +69,4 @@
     <name>VBoxGlobal</name>
     <message numerus="yes">
-        <location filename="../src/globals/VBoxGlobal.h" line="164"/>
         <source>%n year(s)</source>
         <translation>
@@ -70,5 +76,4 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/globals/VBoxGlobal.h" line="169"/>
         <source>%n month(s)</source>
         <translation>
@@ -78,5 +83,4 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/globals/VBoxGlobal.h" line="174"/>
         <source>%n day(s)</source>
         <translation>
@@ -86,5 +90,4 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/globals/VBoxGlobal.h" line="179"/>
         <source>%n hour(s)</source>
         <translation>
@@ -94,5 +97,4 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/globals/VBoxGlobal.h" line="189"/>
         <source>%n second(s)</source>
         <translation>
@@ -102,5 +104,4 @@
     </message>
     <message numerus="yes">
-        <location filename="../src/globals/VBoxGlobal.h" line="184"/>
         <source>%n minute(s)</source>
         <translation>
@@ -113,5 +114,4 @@
     <name>VBoxTakeSnapshotDlg</name>
     <message numerus="yes">
-        <location filename="../src/VBoxTakeSnapshotDlg.cpp" line="73"/>
         <source>Warning: You are taking a snapshot of a running machine which has %n immutable image(s) attached to it. As long as you are working from this snapshot the immutable image(s) will not be reset to avoid loss of data.</source>
         <translation>